unit Bode;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ADport, sysUtils, Messages,
  clipBrd, spin, adexcept, inifiles,
  jmmUtil, graphe, Main, OscConst, ComCtrls, ImgList, ToolWin;

const
  MaxVecteurOsc = 2500;

type
  indiceVoieOsc = 0..2;
  indiceVecteurOsc = 0..MaxVecteurOsc;
  VecteurOsc = array[indiceVecteurOsc] of integer;
  TvoieOsc = class
       Gauge : TprogressBar;
       Valeur : VecteurOsc;
       increment,offset,zero : extended;
       valeurEff,valeurDC : extended;
       procedure Calcul(Nbre : integer);
  end;

  TBodeForm = class(TForm)
    SaveDialog: TSaveDialog;
    Oscillo: TPaintBox;
    PanelValeur: TPanel;
    GroupBox3: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    LabelGain: TLabel;
    LabelPhase: TLabel;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    NumVoieRG: TRadioGroup;
    ToolBar1: TToolBar;
    ImageList1: TImageList;
    StopBtn: TToolButton;
    EnregistreBtn: TToolButton;
    UndoBtn: TToolButton;
    ResetDataBtn: TToolButton;
    AddDataBtn: TToolButton;
    RegSaveBtn: TToolButton;
    ExitBtn: TToolButton;
    StatusBar: TStatusBar;
    procedure SaveItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure ClipSaveBtnClick(Sender: TObject);
    procedure ResetDataBtnClick(Sender: TObject);
    procedure VoieFreqClick(Sender: TObject);
    procedure RegNewFileClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure AddDataBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ExitBtnClick(Sender: TObject);
    procedure GainClick(Sender: TObject);
    procedure PhaseClick(Sender: TObject);
  private
    voieCourante : indiceVoieOsc;
    chaineOsc : ansiString;
    NbreCourant,NbrePointsOsc,NbrePointsPeriode,NbreCarac : integer;
    AcqFaite : boolean;
    LectureVoie : Tlecture;
    VoieOsc : array[indiceVoieOsc] of TvoieOsc;
    voieRef : integer;
    NonSauve : boolean;
    Procedure SetBoutonAcq;
    procedure TriggerAvail(CP: TObject; Count: Word);
    procedure ChaineAvail(chaine: ansiString);
  public
    Graphe : Tgraphe;
  protected
  end;

var
  BodeForm: TBodeForm;

implementation

uses voieBode, voieFreq, tds200dde, voieGainU, voiePhaseU;

{$R *.DFM}

procedure TBodeForm.SaveItemClick(Sender: TObject);
begin
     if SaveDialog.Execute then begin
         Graphe.SaveData(saveDialog.FileName);
         NonSauve := false;
     end;
end;

procedure TBodeForm.FormCreate(Sender: TObject);

Procedure Defaut;
begin with graphe do begin
       avecAxeY := true;
       with voie[voieF] do begin
              Nom := 'f';
              Unite := 'Hz';
              Signif := 'frquence';
              Command := '';
              Active := true;
              Positive := true;
              Mini := 100;
              Maxi := 10000;
              axeLog := true;
              axedB := false;
              LabelVoie := Label1;
        end;
        with voie[voieGain] do begin
              Nom := 'G';
              Unite := '';
              Signif := 'gain';
              Command := '';
              Active := true;
              Positive := true;
              Mini := 0.1;
              Maxi := 10;
              axeLog := false;
              axedB := true;
              LabelVoie := LabelGain;
        end;
       with voie[voiePhase] do begin
              Nom := '';
              if enDegre then Unite := '' else Unite := 'rad';
              Signif := 'phase';
              Command := '';
              Active := true;
              Positive := false;
              Mini := -180;
              Maxi := 180;
              axeLog := false;
              axedB := false;
              LabelVoie := LabelPhase;
        end;
        DerniereVoie := voiePhase;
        voieRef := NumVoieRG.ItemIndex+1;
end end;

procedure LitConfig;
const Titre ='Bode';
var Ini : TiniFile;
begin
      Ini := TiniFile.Create(NomFichierIni);
      ConstanteDlg.NomConstEdit.text := Ini.ReadString('Constante','Nom','');
      ConstanteDlg.UniteConstEdit.text := Ini.ReadString('Constante','Unite','');
with graphe do begin
      with voie[voieF] do begin
              Maxi := Ini.ReadFloat(Titre,'MaxiF',maxi);
              Mini := Ini.ReadFloat(Titre,'MiniF',mini);
              axeLog := Ini.ReadBool(Titre,'LogX',true);
       end;
       with voie[voieGain] do begin
              Maxi := Ini.ReadFloat(Titre,'MaxiGain',maxi);
              Mini := Ini.ReadFloat(Titre,'MiniGain',mini);
              Couleur := Ini.ReadInteger(Titre,'CouleurG',couleur);
              axedB := Ini.ReadBool(Titre,'LogY',true);
              if axedB and (Mini<1e-5) then mini := 0.01;
       end;
       with voie[voiePhase] do begin
              Couleur := Ini.ReadInteger(Titre,'CouleurP',couleur);
              EnDegre := Ini.ReadBool(Titre,'Degre',true);
              Maxi := Ini.ReadFloat(Titre,'MaxiPhase',maxi);
              Mini := Ini.ReadFloat(Titre,'MiniPhase',mini);
       end;
       VoieRef := Ini.ReadInteger(Titre,'Ref',1);
       NumVoieRG.ItemIndex := voieRef-1;
       derniereVoie := voiePhase;
       Ini.Free;
end end;

var v : indiceVoieMult;
    j : integer;
begin
  Graphe := Tgraphe.Create;
  Graphe.Canvas := Oscillo.Canvas;
  for v := voieF to voiePhase do with graphe.voie[v] do begin
      for j := 0 to MaxVecteurMult do
          incertitude[j] := 0;
  end;
  Defaut;
  LitConfig;
  voieOsc[0] := tvoieOsc.create;  
  voieOsc[1] := tvoieOsc.create;
  voieOsc[1].gauge := progressBar2;
  voieOsc[2] := tvoieOsc.create;
  voieOsc[2].gauge := progressBar1;
  setBoutonAcq;
end;

procedure TBodeForm.OscilloPaint(Sender: TObject);
begin
     with graphe.voie[voiePhase] do begin
             if enDegre
                then begin
                   mini := 90*round(mini/90);
                   maxi := 90*round(maxi/90);
                   if maxi>180 then maxi := 180;
                   if mini<-180 then mini := -180;
                   if maxi=mini then maxi := mini+90;
                end
                else begin
                   mini := pi/2*round(mini/pi*2);
                   maxi := pi/2*round(maxi/pi*2);
                   if maxi>pi then maxi := pi;
                   if mini<-pi then mini := -pi;
                   if maxi=mini then maxi := mini+pi/2;                   
                end;
     end;
     Graphe.DrawG(Oscillo.clientRect)
end;

procedure TBodeForm.UndoBtnClick(Sender: TObject);
begin // Supprimer dernier point 
     with graphe do if NbrePoints>0 then dec(NbrePoints);
     Oscillo.refresh;
     setBoutonAcq;
end;

procedure TBodeForm.FormClose(Sender: TObject;var Action: TCloseAction);
begin
    if (graphe.NbrePoints>0) and
        NonSauve and 
       (MessageDlg('Sauvegarde',mtConfirmation,[mbYes,mbNo],0)=idYes)
      then SaveItemClick(sender);
    FormMain.setMode(mNone);
    Action := caFree;
end;

procedure TBodeForm.RegSaveBtnClick(Sender: TObject);
begin
     if ConstanteDlg.showModal=mrOk then begin
        FormDDE.EnvoieDonneesMultimetre(true,true,graphe,
           'Diagramme de Bode avec '+FormMain.identiteScope);
        NonSauve := false;
     end;
end;

procedure TBodeForm.ClipSaveBtnClick(Sender: TObject);
begin
     FormDDE.EnvoieDonneesMultimetre(false,true,graphe,
           'Diagramme de Bode avec '+FormMain.identiteScope);
     NonSauve := false;           
end;

procedure TBodeForm.SetBoutonAcq;
begin with graphe do begin
     EnregistreBtn.enabled := NbrePoints<MaxVecteurMult;
     UndoBtn.Visible := NbrePoints>0;
     ResetDataBtn.Visible := NbrePoints>0;
     AddDataBtn.Visible := NbrePoints>1;
     RegSaveBtn.Visible := NbrePoints>3;
end end;

procedure TBodeForm.ResetDataBtnClick(Sender: TObject);
begin
     if OK('Suppression des donnes courantes') then begin
        Graphe.NbrePoints := 0;
        Oscillo.refresh;
        setBoutonAcq;
     end;
end;

procedure TBodeForm.VoieFreqClick(Sender: TObject);
begin
     if VoieXDlg=nil then
        Application.CreateForm(TVoieXDlg, VoieXDlg);
     VoieXDlg.voieLue := graphe.voie[voieF];
     if VoieXDlg.ShowModal=mrOK then with graphe.voie[voieF] do begin
        LabelVoie.color := couleur;
        Oscillo.invalidate;
        setBoutonAcq;
     end;   
end;

procedure TBodeForm.EnregistreBtnClick(Sender: TObject);
var deuxVoiesActives : boolean;
    modifGamme : boolean;
    buffer : string;

procedure LitCourbes;

procedure LitVoie(Avoie : indiceVoieOsc);

{$IFDEF test}
Procedure LitFichier;

function valeurHexa(C : char) : integer;
begin
    if C in ['0'..'9']
       then result := ord(C)-ord('0')
       else result := 10+ord(C)-ord('A')
end;
var fichier : File of char;
    FichierT : TextFile;
    C : char;
    nombre : String;
    nombreEnCours : boolean;
    i : integer;
begin
    AssignFile(Fichier,'TestVoie'+intTostr(Avoie)+'.trc');
    AssignFile(FichierT,'Voie'+intTostr(Avoie)+'.txt');
    Rewrite(FichierT);
    Reset(Fichier);
    nombreEnCours := false;
    i := 1;
    while not eof(Fichier) do begin
          read(fichier,C);
          case C of
             #0..#32 : ;
             '[' : begin
               nombreEnCours := true;
               nombre :='';
             end;
             ']' : begin
                nombreEnCours := false;
                voieOsc[Avoie].valeur[i] := valeurHexa(nombre[1])*16+valeurHexa(nombre[2]);
                writeln(fichierT,voieOsc[Avoie].valeur[i]);                
                inc(i);
             end;
             else if nombreEnCours
               then nombre := nombre+C
               else begin
                  voieOsc[Avoie].valeur[i] := ord(C);
                  writeln(fichierT,voieOsc[Avoie].valeur[i]);
                  inc(i);
               end;
          end;
    end;
    CloseFile(Fichier);
    CloseFile(FichierT);
end;
{$ENDIF}

begin
     voieCourante := Avoie;
     FormMain.EnvoieCommande(SetSourceOsc+intToStr(aVoie));
     DelaySec(0.22);
     if Avoie=1 then begin
        voieOsc[voieX].Increment := FormMain.GetFloat(Xinc);
        voieOsc[voieX].offset := 0;
        voieOsc[voieX].zero := FormMain.GetFloat(Xzero);
     end;
{$IFDEF test}
     voieOsc[Avoie].Increment := dixReel(Avoie-3);
{$ELSE}
     voieOsc[Avoie].Increment := FormMain.GetFloat(Yinc);
     voieOsc[Avoie].Offset := FormMain.GetFloat(Yoffset);
     voieOsc[Avoie].zero := FormMain.GetFloat(Yzero);
{$ENDIF}
     NbreCourant := 0;
     AcqFaite := false;
     LectureVoie := lectDiese;
     if FormMain.oscillo=oSerie then begin
     FormMain.VoieSerie.OnTriggerAvail := TriggerAvail;
     FormMain.onChaineAvail := chaineAvail;
     end;
     FormMain.EnvoieCommande(GetData);
     arretLecture := false;
     stopBtn.Visible := true;
{$IFDEF test}
     AcqFaite := true;
     NbrePointsOsc := 2500;
     litFichier;
{$ELSE}
     repeat
         if (NbreCourant-voieOsc[Avoie].Gauge.position)>(NbrePointsOsc div 32) then
            voieOsc[Avoie].Gauge.position := NbreCourant;
            FormMain.voieSerie.processCommunications;
         Application.processMessages;
     until AcqFaite or arretLecture;
{$ENDIF}
     LectureVoie := lectNone;
     stopBtn.Visible := false;
     if FormMain.oscillo=oSerie then begin
     FormMain.VoieSerie.OnTriggerAvail := nil;
     FormMain.onChaineAvail := nil;
     end;
     if AcqFaite
       then voieOsc[Avoie].Gauge.position := NbrePointsOsc
       else showMessage('Acquisition de CH'+IntToStr(Avoie)+' non effectue par l''ordinateur');
end;

var reponse : string;
    voie : indiceVoieOsc;
begin
     AcqFaite := false;
     setBoutonAcq;
     ProgressBar1.position := 0;
     ProgressBar2.position := 0;
     ProgressBar1.max := 2500;
     ProgressBar2.max := 2500;
     DeuxVoiesActives := true;
     for voie  := 1 to 2 do begin
        reponse := FormMain.GetString(CHactive+intToStr(voie)+'?');
        DeuxVoiesActives :=  DeuxVoiesActives and
            (pos('ON',reponse)>0) or (pos('1',reponse)>0);
     end;
     if DeuxVoiesActives
        then for voie  := 1 to 2 do begin
            LitVoie(voie);
            if not AcqFaite then exit;
        end
        else Erreur('Deux voies actives ncessaires pour mesurer gain/phase');
end; // litCourbes

procedure CalculGainPhase;
var i : integer;
    quartPeriode : integer;
    somme,sommeQuartPeriode : extended;
    exposant,mantisse,coeff : extended;
{ <v1,v2>=v1eff*v2eff*cos }
{ <v1,v2 pi/2 >=v1eff*v2eff*sin }
begin
           voieOsc[1].calcul(NbrePointsPeriode);
           voieOsc[2].calcul(NbrePointsPeriode);
           Somme := 0;
           for i := 0 to pred(NbrePointsPeriode) do begin
               Somme := Somme+
                    (voieOsc[1].valeur[i]-voieOsc[1].valeurDC)*
                    (voieOsc[2].valeur[i]-voieOsc[2].valeurDC);
           end;
           quartPeriode := NbrePointsPeriode div 4;
           SommeQuartPeriode := 0;
           for i := 0 to pred(NbrePointsPeriode) do
               SommeQuartPeriode := SommeQuartPeriode+
                   (voieOsc[1].valeur[i]-voieOsc[1].valeurDC)*
                   (voieOsc[2].valeur[i+quartPeriode]-voieOsc[2].valeurDC);
           graphe.voie[voiePhase].valeurCourante := atan2(SommeQuartperiode,Somme);
           if voieRef=1 then graphe.voie[voiePhase].valeurCourante :=
                            -graphe.voie[voiePhase].valeurCourante;
           graphe.voie[voieGain].valeurCourante :=
              voieOsc[3-voieRef].valeurEff/voieOsc[voieRef].valeurEff;
           with graphe.voie[voieGain] do begin
               if valeurCourante>maxi then begin { 512 }
                  exposant := intMaths(log(abs(valeurCourante))); { 2 }
                  coeff := exp(exposant*ln10); { 100 }
                  mantisse := int(abs(valeurCourante)/coeff); { 5 }
                  maxi := (mantisse+1)*coeff; { 600 }
                  modifGamme := true;
               end;
               if valeurCourante<mini then begin { 512 }
                  exposant := intMaths(log(abs(valeurCourante))); { 2 }
                  coeff := exp(exposant*ln10); { 100 }
                  mantisse := int(abs(valeurCourante)/coeff); { 5 }
                  mini := mantisse*coeff; { 600 }
                  modifGamme := true;
               end;
           end;
end;

function LitFrequence : boolean;

Function CherchePeriode(Avoie : indiceVoieOsc) : boolean;
var i : integer;
    montant : boolean;
    debut,fin,sommeDC : integer;
begin with voieOsc[Avoie] do begin
   SommeDC := 0;
   for i := 0 to pred(NbrePointsOsc) do
       SommeDC := SommeDC+valeur[i];
   valeurDC := SommeDC/NbrePointsOsc;
   montant := valeur[0]<valeurDC;
   i := 0;
   if montant
     then while (i<NbrePointsOsc) and (valeur[i]<valeurDC) do inc(i)
       { front montant, en-dessus >= }
     else while (i<NbrePointsOsc) and (valeur[i]>valeurDC) do inc(i);
       { front descendant, en-dessous <= }
   if i=0 { pile moy ! } then montant := valeur[1]>valeurDC;
   debut := i;
   repeat inc(i)
   until abs(valeur[i]-valeurDC)>8; { hysteresis }
   if montant
     then while (i<NbrePointsOsc) and (valeur[i]>=valeurDC) do inc(i)
       { front montant on repasse en-dessous < }
     else while (i<NbrePointsOsc) and (valeur[i]<=valeurDC) do inc(i);
       { front descendant, on repasse au-dessus > }
   repeat inc(i)
   until abs(valeur[i]-valeurDC)>8; { hysteresis pour liminer bruit }
   if montant
      then while (i<NbrePointsOsc) and (valeur[i]<valeurDC) do inc(i)
        { front montant, en-dessus >= }
      else while (i<NbrePointsOsc) and (valeur[i]>valeurDC) do inc(i);
       { front descendant, en-dessous <= }
   fin := i;
   NbrePointsPeriode := fin-debut;
   result := fin<(NbrePointsOsc-(NbrePointsPeriode div 4));
   if not result then begin
         Erreur('Impossible de dterminer la frquence : moins de deux priodes');
         exit;
   end;
   result := NbrePointsPeriode>256;
   if not result then begin
         Erreur('Impossible de dterminer la frquence : plus de dix priodes');
         exit;
   end;
   with graphe.voie[voieF] do
       valeurCourante := 1/NbrePointsPeriode/voieOsc[voieX].increment;
end end; // CherchePeriode

var exposant,mantisse,coeff : extended;
    voie : indiceVoieOsc;
begin
      if voieOsc[1].increment>=voieOsc[2].increment
         then voie := 1
         else voie := 2;  // sur le signal le plus fort
      result := cherchePeriode(voie);
      if result then with graphe.voie[voieF] do begin
            if valeurCourante<mini then begin
               exposant := intMaths(log(abs(valeurCourante)));
               coeff := exp(exposant*ln10);
               mantisse := int(abs(valeurCourante)/coeff);
               mini := mantisse*coeff;
               modifGamme := true;
            end;
            if valeurCourante>maxi then begin
               exposant := intMaths(log(abs(valeurCourante)));
               coeff := exp(exposant*ln10);
               mantisse := int(abs(valeurCourante)/coeff);
               maxi := (mantisse+1)*coeff;
               modifGamme := true;
            end;
       end;
end;

var v : indiceVoieBode;
    x,y : integer;
begin with graphe do begin
     ModifGamme := false;
     voieRef := NumvoieRG.ItemIndex+1;
     for v := voieF to derniereVoie do
         voie[v].NumVoie := voieRef;
     LitCourbes;
     if not(deuxVoiesActives) or
        not(AcqFaite) or
        not(LitFrequence) then exit;
     calculGainPhase;
     if ModifGamme then Oscillo.Invalidate;
     canvas.brush.style := bsSolid;
     for v := voieF to derniereVoie do with voie[v] do begin
          LabelVoie.caption := AffVoltmetre;
          valeur[NbrePoints] := valeurCourante;
          valeurAff := valeurCourante;
          if v<>voieF then begin
             x := voie[voieF].GrandeurToEcran(voie[voieF].valeurCourante);
             y := grandeurToEcran(valeurCourante);
             Canvas.Pen.color := couleur;
             Canvas.Brush.color := couleur;
             Canvas.Rectangle(x-dimPoint,y-dimPoint,x+dimPoint,y+dimPoint);
           end;  
     end;
     inc(NbrePoints);
     NonSauve := true;
     setBoutonAcq;
end end; // EnregistreBtnClick 

procedure TBodeForm.RegNewFileClick(Sender: TObject);
begin
     FormDDE.EnvoieDonneesMultimetre(true,true,graphe,
           'Diagramme de Bode avec '+FormMain.identiteScope)
end;

procedure TBodeForm.FormDestroy(Sender: TObject);

procedure SauveConfig;
const titre='Bode';
var Ini : TMemIniFile;
begin with graphe do begin
      try
      Ini := TMemIniFile.Create(NomFichierIni);
      with voie[voieF] do begin
          Ini.WriteFloat(Titre,'MaxiF',Maxi);
          Ini.WriteFloat(Titre,'MiniF',Mini);
          Ini.WriteBool(Titre,'LogX',axeLog);
      end;
      with voie[voieGain] do begin
          Ini.WriteFloat(Titre,'MaxiGain',Maxi);
          Ini.WriteFloat(Titre,'MiniGain',Mini);          
          Ini.WriteInteger(Titre,'couleurG',Couleur);
          Ini.WriteBool(Titre,'logY',axedB);
      end;
      with voie[voiePhase] do begin
          Ini.WriteInteger(Titre,'couleurP',Couleur);
          Ini.WriteBool(Titre,'Degre',enDegre);
          Ini.WriteFloat(Titre,'MaxiPhase',Maxi);
          Ini.WriteFloat(Titre,'MiniPhase',Mini);
      end;
      Ini.WriteInteger(Titre,'Ref',VoieRef);
      Ini.UpdateFile;
      Ini.Free;
      except
      end;
end end;

var v : indiceVoieOsc;
begin
     SauveConfig;
     for v := 0 to 2 do voieOsc[v].free;
     Graphe.Free;
     BodeForm := nil;
end;

procedure TBodeForm.StopBtnClick(Sender: TObject);
begin
     ArretLecture := true;
     StopBtn.visible := false;
     FormMain.EnvoieCommande('*RST');
end;

procedure TBodeForm.AddDataBtnClick(Sender: TObject);
begin
     FormDDE.AjouteDonneesMultimetre(graphe)
end;

procedure TBodeForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
     if (key=' ') and enregistreBtn.enabled then begin
         enregistreBtnClick(sender);
         key := #0;
     end;
end;

procedure TBodeForm.ExitBtnClick(Sender: TObject);
begin
     close
end;

procedure TBodeForm.TriggerAvail(CP: TObject; Count: Word);
var i : integer;
    carac : ansiChar;
begin
   for i := 1 to count do begin
      carac := FormMain.voieSerie.GetChar;
      case LectureVoie of
           lectDiese : if carac='#' then lectureVoie := lectNcarac;
           lectNcarac : begin
              NbreCarac := StrToInt(carac); // 4 ? 
              NbreCourant := 0;
              ChaineOsc := '';
              lectureVoie := lectNbyte;
           end;
           lectNbyte : begin
               inc(NbreCourant);
               chaineOsc := chaineOsc+carac;
               if NbreCourant=NbreCarac then begin
                  NbrePointsOsc := strToInt(chaineOsc); // 2500 ?
                  lectureVoie := lectData;
                  NbreCourant := 0;
                  voieOsc[voieCourante].Gauge.max := NbrePointsOsc;
               end;
           end;
           lectData : begin
                voieOsc[voieCourante].valeur[NbreCourant] := ord(carac);
                inc(NbreCourant);
                if NbreCourant>=NbrePointsOsc then begin
                   AcqFaite := true;
                   lectureVoie := lectNone;
                end;
            end;
       end
   end;
end;

procedure TBodeForm.ChaineAvail(Chaine: ansiString);
var i : integer;
    carac : ansiChar;
begin
   for i := 1 to length(chaine) do begin
      carac := chaine[i];
//  <header> = CURVe #n<yyyy> n tant le nombre de y 
      case LectureVoie of
           lectDiese : if carac='#' then lectureVoie := lectNcarac;
           lectNcarac : begin
              NbreCarac := StrToInt(carac); { 4 ? }
              NbreCourant := 0;
              ChaineOsc := '';
              lectureVoie := lectNbyte;
           end;
           lectNbyte : begin
               inc(NbreCourant);
               chaineOsc := chaineOsc+carac;
               if NbreCourant=NbreCarac then begin
                  NbrePointsOsc := strToInt(chaineOsc); // 2500 ?
                  lectureVoie := lectData;
                  NbreCourant := 0;
                  voieOsc[voieCourante].Gauge.max := NbrePointsOsc;
               end;
           end;
           lectData : begin
                voieOsc[voieCourante].valeur[NbreCourant] := ord(carac);
                inc(NbreCourant);
                if NbreCourant>=NbrePointsOsc then begin
                   AcqFaite := true;
                   lectureVoie := lectNone;
                end;
            end;
       end
   end;
end;

Procedure TvoieOsc.Calcul(Nbre : integer);
var i : integer;
    x,sommeEff,sommeDC : extended;
begin
    SommeEff := 0;
    SommeDC := 0;
    for i := 0 to pred(Nbre) do begin
        x := valeur[i]-offset;
        SommeEff := SommeEff+sqr(x);
        SommeDC := SommeDC+x;
    end;
    valeurDC := SommeDC/Nbre;
    valeurEff := increment*sqrt(SommeEff/Nbre-sqr(valeurDC));
    valeurDC := valeurDC+offset;
 // pour calcul direct plus rapide dans la dtermination de la phase
end;

procedure TBodeForm.GainClick(Sender: TObject);
begin
     if VoieGainDlg=nil then
         Application.CreateForm(TVoieGainDlg, VoieGainDlg);
     if VoieGainDlg.ShowModal=mrOK then begin
        with graphe.voie[voieGain] do
             LabelVoie.color := couleur;
        Oscillo.invalidate;
        setBoutonAcq;
     end;
end;

procedure TBodeForm.PhaseClick(Sender: TObject);
begin
     if VoiePhaseDlg=nil then
        Application.CreateForm(TVoiePhaseDlg, VoiePhaseDlg);
     if VoiePhaseDlg.ShowModal=mrOK then begin
        with graphe.voie[voiePhase] do begin
             if enDegre then unite := '' else unite := 'rad';
             LabelVoie.color := couleur;
        end;
        Oscillo.invalidate;
        setBoutonAcq;
     end;
end;

end.


