unit multdde;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, FileCtrl, inifiles, clipbrd,
  graphe, jmmUtil, ComCtrls;

type
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    Donnees: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    procedure AjouteConst;
  public
      procedure Execute(Ordre : shortString);
      procedure AjouteDonneesMultimetre(graphe : Tgraphe);
      procedure EnvoieDonneesMultimetre(DDE : boolean;
          graphe : Tgraphe;titre : shortString);
  end;

var
  FormDDE: TFormDDE;

implementation

uses multim, oscConst;

{$R *.DFM}

procedure TFormDDE.AjouteConst;
var valeurConst : extended;
begin with ConstanteDlg do begin
     if NomConstEdit.text='' then exit;
     try
        ValeurConst := StrToFloat(ValeurConstEdit.text);
        Donnees.Lines.Add('');
        Donnees.Lines.Add(NomConstEdit.text+crTab);
        Donnees.Lines.Add(UniteConstEdit.text+crTab);
        Donnees.Lines.Add(FloatToStrWin(valeurConst,precisionMin)+crTab);
     except
     end;
end end;

procedure TFormDDE.Execute(Ordre : shortString);
var Buf: PChar;
begin
     ClientDDE.SetLink('Regressi','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
        then begin
            Buf := StrAlloc(Succ(Length(Ordre)));
            if not ClientDDE.ExecuteMacro(StrPCopy(Buf,Ordre), false) then
                ShowMessage(Ordre+' non excut');
            StrDispose(Buf);
            ClientDDE.CloseLink;
        end
        else ShowMessage('Impossible de lancer Regressi');
end;


procedure TFormDDE.EnvoieDonneesMultimetre(DDE : boolean;graphe : Tgraphe;
          Titre : shortString);
var i : indiceVecteur;
    j : integer;
    ligne : shortString;
    ligneOK : boolean;
begin with graphe do begin
     Tri;
     Screen.Cursor := crHourGlass;
     Donnees.Clear;
     Donnees.Lines.Add(Application.exeName);
     if ConstanteDlg.NewPageCB.itemIndex=0
        then Donnees.Lines.Add(Titre)
        else Donnees.Lines.Add('');
     Donnees.Lines.Add(ConstanteDlg.EditComm.text);
     Ligne := '';
     for j := voieX to DerniereVoie do with voie[j] do
         ligne := ligne + nom + crTab;
     Donnees.Lines.Add(ligne);
     Ligne := '';
     for j := voieX to DerniereVoie do with voie[j] do
         ligne := ligne + unite + crTab;
     Donnees.Lines.Add(ligne);
     Ligne := '';
     for j := voieX to DerniereVoie do with voie[j] do
         ligne := ligne + commentaire + crTab;
     Donnees.Lines.Add(ligne);
     for i := 0 to pred(NbrePoints) do begin
         ligne := '';
         ligneOK := true;
         for j := voieX to DerniereVoie do with voie[j] do begin
            ligne := ligne + FloatToStrWin(valeur[i],precisionMin) + crTab;
            if valeur[i]=sansSignif then begin
               ligneOK := false;
               break;
            end;
         end;
         if ligneOK then Donnees.Lines.Add(ligne);
     end;
     AjouteConst;
     Donnees.lines.Add(symbReg2+IntToStr(NbrePoints)+' INCERT');
     ligne := '';
     for i := 0 to pred(NbrePoints) do begin
         ligne := '';
         for j := voieX to DerniereVoie do
             ligne := ligne + FloatToStrWin(voie[j].incertitude[i],precisionMin)+crTab;
         Donnees.Lines.Add(ligne);
     end;
     Donnees.SelectAll;
     ClipBoard.AsText := Donnees.Text;
     if DDE then if ConstanteDlg.NewPageCB.itemIndex=0
          then Execute('CLIP|LOAD')
          else Execute('CLIP|ADD');
     Screen.Cursor := crDefault;
     ConstanteDlg.NewPageCB.itemIndex := 1;
end end;

procedure TFormDDE.AjouteDonneesMultimetre(graphe : Tgraphe);
var i : indiceVecteur;
    j : integer;
    ligne : shortString;
begin with graphe do begin
     Tri;
     Screen.Cursor := crHourGlass;
     Donnees.Clear;
     Ligne := '';
     for j := voieX to DerniereVoie do with voie[j] do
         ligne := ligne + nom + crTab;
     Donnees.Lines.Add(ligne);
     for i := 0 to pred(NbrePoints) do begin
         ligne := '';
         for j := voieX to DerniereVoie do
            ligne := ligne + FloatToStrWin(voie[j].valeur[i],precisionMin) + crTab;
         Donnees.Lines.Add(ligne);
     end;
     ClipBoard.AsText := Donnees.text;
     Execute('CLIP|PLUS');
     Screen.Cursor := crDefault;
end end;

procedure TFormDDE.FormCreate(Sender: TObject);
var Ini : TiniFile;
begin
    Ini := TiniFile.create(WinDir+'Regressi.INI');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','c:\regwin\regressi.exe');
    Ini.Free;
end;

procedure TFormDDE.ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);

Procedure FocusHP(NewPage,lectureConst : boolean);
begin
   with ConstanteDlg do begin
      if NewPage
         then NewPageCB.itemIndex := 1
         else NewPageCB.itemIndex := 0;
      if NewPage and lectureConst then begin
          Donnees.clear;
          Donnees.PasteFromClipboard;
          if Donnees.Lines.count>1 then begin
               NomConstEdit.text := Donnees.Lines[0];
               UniteConstEdit.text := Donnees.Lines[1];
          end;
      end;
   end;
             MultimetreForm.Show;
             MultimetreForm.SetFocus
end;

var Fonction,NomFichier : shortString;
    ArgStart,ArgEnd : byte;
begin
     if (Msg.Count >= 1) then begin
       try
       ArgStart := Pos('(',Msg[0]);
       ArgEnd := Pos(')',Msg[0]);
       if (ArgStart >= ArgEnd)
          then begin
             NomFichier := '';
             ArgStart := length(Msg[0])
          end
          else begin
              NomFichier := Copy(Msg[0], Succ(ArgStart), ArgEnd - Succ(ArgStart));
              dec(ArgStart)
          end;
       Fonction := Copy(Msg[0], 1, ArgStart);
       if (CompareText('CONFIG|LOAD',Fonction) = 0) or
          (CompareText('FILE|LOAD',Fonction) = 0) then begin
           FocusHP(true,false);
           exit
       end;
       if (CompareText('CONFIG|SAVE',Fonction) = 0) or
          (CompareText('FILE|SAVE',Fonction) = 0) then begin
           FocusHP(true,false);
           exit
       end;
       if CompareText('FOCUS',Fonction) = 0 then begin
           FocusHP(false,true);
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           FocusHP(true,true);
           exit;
       end;
       MessageDlg('Fonction inconnue : ' + Msg[0], mtError, [mbOK], 0);
       except
       end;
     end;
end;

end.
