unit Multim;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ADport, sysUtils, Messages,
  clipBrd, spin, adexcept, inifiles, math,
  jmmUtil, graphe, Main, OscConst;

type
  TMultimetreForm = class(TForm)
    SaveDialog: TSaveDialog;
    Oscillo: TPaintBox;
    BoutonsPanel: TPanel;
    FileSaveBtn: TSpeedButton;
    ClipSaveBtn: TSpeedButton;
    RegSaveBtn: TSpeedButton;
    ResetDataBtn: TSpeedButton;
    EnregistreBtn: TSpeedButton;
    UndoBtn: TSpeedButton;
    PanelValeur: TPanel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    Timer: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    StopBtn: TSpeedButton;
    AddDataBtn: TSpeedButton;
    PanelErreurLecture: TPanel;
    ExitBtn: TSpeedButton;
    TraceGB: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    EmissionEdit: TEdit;
    ReceptionEdit: TEdit;
    procedure SaveItemClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure EnregistreBtnClick(Sender: TObject);
    procedure OscilloPaint(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RegSaveBtnClick(Sender: TObject);
    procedure ClipSaveBtnClick(Sender: TObject);
    procedure ResetDataBtnClick(Sender: TObject);
    procedure VoieFreqClick(Sender: TObject);
    procedure VoieAnaClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure RegNewFileClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure AddDataBtnClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure ExitBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
  private
    GrapheMult : Tgraphe;
    Procedure SetBoutonAcq;
    Procedure SetVoies;
    Procedure EnvoieDemande;
  public
  protected
  end;

var
  MultimetreForm: TMultimetreForm;

implementation

uses voies, voieFreq, tds200dde;

{$R *.DFM}

procedure TMultimetreForm.SaveItemClick(Sender: TObject);
begin
     timer.enabled := false;
     if SaveDialog.Execute then begin
         Screen.Cursor := crHourGlass;
         GrapheMult.SaveData(saveDialog.FileName);
         Screen.Cursor := crDefault;
     end;
     timer.enabled := true;
end;

procedure TMultimetreForm.FormCreate(Sender: TObject);
var Ini : TiniFile;

procedure LitConfig;
var j : indiceVoieMult;
    titre : string;
begin with grapheMult do begin
       for j := voieX to NbreVoiesMax do with voie[j] do begin
              Titre := 'Voie'+IntToStr(j);
              Nom := Ini.ReadString(Titre,'Nom',nom);
              Unite := Ini.ReadString(Titre,'Unite',unite);
              Signif := Ini.ReadString(Titre,'Signif',signif);
              Commentaire := Ini.ReadString(Titre,'Comment',commentaire);
              Command := Ini.ReadString(Titre,'Command',command);
              Active := Ini.ReadBool(Titre+IntToStr(j),'Active',active);
              Positive := Ini.ReadBool(Titre,'Positive',positive);
              CalculIncertitude := TcalculIncertitude(Ini.ReadInteger(Titre,'Incertitude',0));
              Maxi := Ini.ReadFloat(Titre,'Maxi',maxi);
              if j=voieX
                 then Mini := Ini.ReadFloat(Titre,'Mini',mini)
                 else if positive
                      then mini := 0
                      else mini := -maxi;
              NumVoie := Ini.ReadInteger(Titre,'Numro',NumVoie);
              Couleur := Ini.ReadInteger(Titre,'Couleur',couleur);
              if (numvoie<>1) and (numVoie<>2) then numVoie := 1;
       end;
       voie[voieX].axeLog := Ini.ReadBool('Measure','LogX',true);
end end;

begin
  if VoiesDlg=nil then
        Application.CreateForm(TVoiesDlg, VoiesDlg);
  GrapheMult := Tgraphe.Create;
  with GrapheMult do begin
     Canvas := Oscillo.Canvas;
     voie[0].LabelVoie := Label1;
     voie[1].LabelVoie := Label2;
     voie[2].LabelVoie := Label3;
     voie[3].LabelVoie := Label4;
     voie[4].LabelVoie := Label5;
     voie[0].GBVoie := GroupBox1;
     voie[1].GBVoie := GroupBox2;
     voie[2].GBVoie := GroupBox3;
     voie[3].GBVoie := GroupBox4;
     voie[4].GBVoie := GroupBox5;
  end;   
  Ini := TiniFile.Create(NomFichierIni);
  ConstanteDlg.NomConstEdit.text := Ini.ReadString('Constante','Nom','');
  ConstanteDlg.UniteConstEdit.text := Ini.ReadString('Constante','Unite','');
  LitConfig;
  Ini.Free;
  setVoies;
  {$IFDEF Trace}
  TraceGB.visible := true;
  {$ENDIF}
  setBoutonAcq;
end;

procedure TMultimetreForm.EnregistreBtnClick(Sender: TObject);
begin
     if grapheMult.PointCourantOK then begin
           grapheMult.EnregistrePointCourant;
           setBoutonAcq;
     end
end;

procedure TMultimetreForm.OscilloPaint(Sender: TObject);
begin
     GrapheMult.DrawG(Oscillo.clientRect)
end;

procedure TMultimetreForm.UndoBtnClick(Sender: TObject);
begin // Supprimer dernier point 
     with grapheMult do if NbrePoints>0 then dec(NbrePoints);
     Oscillo.refresh;
     setBoutonAcq;
end;

procedure TMultimetreForm.FormClose(Sender: TObject;var Action: TCloseAction);
begin
    Timer.enabled := false;
    if (grapheMult.NbrePoints>0) and
       (MessageDlg('Sauvegarde',mtConfirmation,[mbYes,mbNo],0)=idYes)
        then SaveItemClick(sender);
    FormMain.setMode(mNone);
    Action := caFree;
end;

procedure TMultimetreForm.RegSaveBtnClick(Sender: TObject);
begin
     Timer.enabled := false;
     if ConstanteDlg.showModal=mrOk then begin
        FormDDE.EnvoieDonneesMultimetre(true,false,grapheMult,
           'Diagramme de Bode avec '+FormMain.identiteScope);
     end;
     Timer.enabled := true;
end;

procedure TMultimetreForm.ClipSaveBtnClick(Sender: TObject);
begin
     FormDDE.EnvoieDonneesMultimetre(false,false,grapheMult,
           'Diagramme de Bode avec '+FormMain.identiteScope)
end;

procedure TMultimetreForm.SetBoutonAcq;
begin with grapheMult do begin
     EnregistreBtn.enabled := pointCourantOK and (NbrePoints<MaxVecteurMult);

     UndoBtn.Visible := NbrePoints>0;
     ResetDataBtn.Visible := UndoBtn.Visible;
     AddDataBtn.Visible := UndoBtn.Visible;

     FileSaveBtn.Visible := NbrePoints>2;
     ClipSaveBtn.Visible := FileSaveBtn.Visible;
     RegSaveBtn.Visible := FileSaveBtn.Visible;

     Timer.enabled := NbrePoints<MaxVecteurMult;
end end;

procedure TMultimetreForm.ResetDataBtnClick(Sender: TObject);
begin
     if OK('Suppression des donnes courantes') then begin
        GrapheMult.NbrePoints := 0;
        Oscillo.refresh;
        setBoutonAcq;
     end;
end;

procedure TMultimetreForm.VoieFreqClick(Sender: TObject);
begin
     if VoieXDlg=nil then
        Application.CreateForm(TVoieXDlg, VoieXDlg);
     VoieXDlg.voieLue := grapheMult.voie[voieX];
     if VoieXDlg.ShowModal=mrOK then setVoies;
     Oscillo.invalidate;
     setBoutonAcq;
end;

procedure TMultimetreForm.VoieAnaClick(Sender: TObject);
var j : indiceVoieMult;
begin
     j := (sender as Tcomponent).tag;
     VoiesDlg.voieLue := grapheMult.voie[j];
     VoiesDlg.DesactiveBtn.visible := grapheMult.DerniereVoie>voieA;
     if VoiesDlg.ShowModal=mrOK then setVoies;
     Oscillo.invalidate;
     setBoutonAcq;
end;

Procedure TMultimetreForm.SetVoies;
var i,j : indiceVoieMult;
    cle : boolean;
    sauveVoie : Tvoie;
    sauveDerniereVoie : integer;
    gamme : ansiString;
begin with grapheMult do begin
    i := 2;
    while (i<=NbreVoiesMax) do begin
       sauveVoie := voie[i];
       cle := sauveVoie.active;
       j := pred(i);
       while (j>=1) and (voie[j].active<cle) do begin
             voie[succ(j)] := voie[j];
             dec(j);
        end;
        voie[succ(j)] := sauveVoie;
        inc(i);
    end;
    SauveDerniereVoie := DerniereVoie;
    DerniereVoie := voieX;
    for j := voieA to NbreVoiesMax do with voie[j] do
        if active then inc(DerniereVoie);
    if sauveDerniereVoie<>DerniereVoie then begin
       GrapheMult.NbrePoints := 0;
       Oscillo.invalidate;
    end;
    for j := voieX to DerniereVoie do with voie[j] do begin
           if j=voieX
              then gamme := strValeur(Mini)+'..'+strValeur(Maxi)
              else begin
                  if Positive then gamme := ' ' else gamme := ' ';
                  gamme := signif+gamme+strValeur(Maxi);
              end;
           GBvoie.Caption := 'CH'+IntToStr(numVoie)+' '+gamme;
           LabelVoie.visible := true;
           LabelVoie.color := couleur;
           LabelVoie.caption := nom;
           GBvoie.color := couleur;
    end;
    if derniereVoie<NbreVoiesMax then
       for j := succ(DerniereVoie) to NbreVoiesMax do with voie[j] do begin
           GBvoie.Caption := '';
           LabelVoie.visible := false;
           GBvoie.color := clGray;
       end;
end end;

procedure TMultimetreForm.EnvoieDemande;

procedure getValeurProc(voieCourante : indiceVoieMult);
var erreurLecture : boolean;
begin with grapheMult.voie[voieCourante] do begin
         valeurCourante := FormMain.GetFloat(EnTeteMesure+
                      SetSourceMult+IntToStr(NumVoie)+
                      '; '+SetType+' '+Command+
                      '; '+GetValeurStr);
         if (voieCourante=voieX) and
            (valeurCourante<mini/10) then valeurCourante := Nan;
         erreurLecture :=
                (valeurCourante=NombreErreur) or
                (valeurCourante=NombreTimeOut) or
                isNan(valeurCourante);
         if erreurlecture then begin
                StopBtn.visible := true;
                incertitudeCourante := 0;
                LabelVoie.caption := nom+'='+strValeur(valeurCourante);
                exit;
         end;
         if (voieCourante=voieX) and
            (valeurCourante>8/BaseDeTemps)
              then LabelVoie.caption := 'Base de temps trop lente'
              else LabelVoie.caption := nom+'='+strValeur(valeurCourante);
         setIncertitude;
end end;

var i : indiceVoieMult;
    ModifGamme : boolean;
    exposant,mantisse,coeff : double;
    gammeVoie : ansiString;
begin with grapheMult do begin
     PanelErreurLecture.visible := false;

     BaseDeTemps := FormMain.GetFloat(GetTimeDiv)*10;
     DeltaT := BaseDeTemps/1024;
     DeltaV[1] := FormMain.GetFloat('CH1:SCA?')*8/256;
     DeltaV[2] := FormMain.GetFloat('CH2:SCA?')*8/256;

     for i := voieX to derniereVoie do getValeurProc(i);
     ModifGamme := false;
     for i := voieX to DerniereVoie do with voie[i] do
         if abs(valeurCourante)>maxi then begin { -512 }
               exposant := intMaths(log(abs(valeurCourante))); { 2 }
               coeff := exp(exposant*ln10); { 100 }
               mantisse := int(abs(valeurCourante)/coeff); { 5 }
               maxi := (mantisse+1)*coeff; { 600 }
               if i=voieX
                  then gammeVoie := strValeur(mini)+'..'+strValeur(Maxi)
                  else begin
                     if Positive then gammeVoie := ' +' else gammeVoie := ' ';
                     gammeVoie := signif+gammeVoie+strValeur(Maxi);
                  end;
               GBvoie.Caption := 'CH'+intToStr(numVoie)+' '+gammeVoie;
               modifGamme := true;
          end;
        with voie[voieX] do if abs(valeurCourante)<mini then begin
               exposant := intMaths(log(abs(valeurCourante)));
               coeff := exp(exposant*ln10);
               mantisse := int(abs(valeurCourante)/coeff);
               mini := mantisse*coeff;
               if mini<1 then mini := 1;
               grapheMult.voie[voieX].GBvoie.Caption := 'CH'+intToStr(numVoie)+' '+strValeur(mini)+'..'+strValeur(Maxi);
               modifGamme := true;
        end;
        if ModifGamme then Oscillo.Invalidate;
        Oscillo.Refresh;
        AffichePointCourant(true);
        setBoutonAcq;
end end; { FinDemande }

procedure TMultimetreForm.TimerTimer(Sender: TObject);
begin
      EnvoieDemande
end;

procedure TMultimetreForm.RegNewFileClick(Sender: TObject);
begin
     FormDDE.EnvoieDonneesMultimetre(true,false,grapheMult,
           'Diagramme de Bode avec '+FormMain.identiteScope)
end;

procedure TMultimetreForm.FormDestroy(Sender: TObject);

procedure SauveConfig;
var Ini : TMemIniFile;
    j : indiceVoieMult;
    titre : string;
begin with grapheMult do begin
      try
      Ini := TMemIniFile.Create(NomFichierIni);
      for j := voieX to NbreVoiesMax do with voie[j] do begin
          Titre := 'Voie'+IntToStr(j);
          Ini.WriteString(Titre,'Nom',nom);
          Ini.WriteString(Titre,'Unite',unite);
          Ini.WriteString(Titre,'Signif',signif);
          Ini.WriteString(Titre,'Comment',commentaire);
          Ini.WriteString(Titre,'Command',command);
          Ini.WriteBool(Titre,'Active',active);
          Ini.WriteBool(Titre,'Positive',positive);
          Ini.WriteInteger(Titre,'Incertitude',ord(CalculIncertitude));
          Ini.WriteString(Titre,'Maxi',FloatToStr(Maxi));
          if j=voieX then Ini.WriteString(Titre,'Mini',FloatToStr(Mini));
          Ini.WriteInteger(Titre,'Numro',NumVoie);
          Ini.WriteInteger(Titre,'Couleur',Couleur);          
      end;
      Ini.WriteBool('MODE','LogX',voie[voieX].axeLog);
      Ini.UpdateFile;
      Ini.Free;
      except
      end;
end end;

begin
     SauveConfig;
     GrapheMult.Free;
     MultimetreForm := nil;
end;

procedure TMultimetreForm.StopBtnClick(Sender: TObject);
begin
     ArretLecture := true;
     StopBtn.visible := false;
     FormMain.EnvoieCommande('*RST');
end;

procedure TMultimetreForm.AddDataBtnClick(Sender: TObject);
begin
     FormDDE.AjouteDonneesMultimetre(grapheMult)
end;

procedure TMultimetreForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
     if (key=' ') and enregistreBtn.enabled then begin
         enregistreBtnClick(sender);
         key := #0;
     end;
end;

procedure TMultimetreForm.ExitBtnClick(Sender: TObject);
begin
     close
end;

procedure TMultimetreForm.FormActivate(Sender: TObject);
begin
     Timer.enabled := true
end;

procedure TMultimetreForm.FormDeactivate(Sender: TObject);
begin
     Timer.enabled := false
end;

end.


