unit tds200dde;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, clipbrd,
  graphe, math, jmmUtil, ComCtrls, registry;

type
  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormCreate(Sender: TObject);
    procedure ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);
  private
    procedure AjouteConst(var donnees : TstringList);
  public
      procedure Execute(Ordre : String);
      procedure AjouteDonneesMultimetre(graphe : Tgraphe);
      procedure EnvoieDonneesMultimetre(DDE,Bode : boolean;
          graphe : Tgraphe;titre : String);
      procedure EnvoieDonneesOscillo(DDE,UnePeriode : boolean);
  end;

var
  FormDDE: TFormDDE;

implementation

uses curve, main, multim, oscConst;

{$R *.DFM}

procedure TFormDDE.AjouteConst(var donnees : TstringList);
var valeurConst : extended;
begin with ConstanteDlg do begin
     if NomConstEdit.text='' then exit;
     try
        ValeurConst := StrToFloat(ValeurConstEdit.text);
        Donnees.Add('');
        Donnees.Add(NomConstEdit.text+crTab);
        Donnees.Add(UniteConstEdit.text+crTab);
        Donnees.Add(FloatToStrPoint(valeurConst)+crTab);
     except
     end;
end end;

procedure TFormDDE.Execute(Ordre : String);
var Buf: PChar;
begin
     ClientDDE.SetLink('Regressi','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
        then begin
            Buf := StrAlloc(Succ(Length(Ordre)));
 //           if not ClientDDE.ExecuteMacro(StrPCopy(Buf,Ordre), false) then
                ShowMessage(Ordre+' non excut');
            StrDispose(Buf);
            ClientDDE.CloseLink;
        end
        else ShowMessage('Impossible de lancer Regressi');
end;

procedure TFormDDE.EnvoieDonneesMultimetre(DDE,Bode : boolean;graphe : Tgraphe;
          Titre : String);

Procedure SetPhase;
var i : integer;
    deuxPi : double;
begin with graphe.voie[voiePhase] do begin
       if EnDegre then deuxPi := 360 else DeuxPi := 2*pi;
       for i := 1 to pred(graphe.NbrePoints) do
                Valeur[i] := Valeur[i]-round((Valeur[i]-Valeur[pred(i)])/DeuxPi)*DeuxPi
end end;

var i : indiceVecteur;
    j : indiceVoie;
    ligne : String;
    ligneOK,avecdb : boolean;
    donnees : TstringList;
    nbreCourbes : integer;
begin with graphe do begin
     Tri;
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     Donnees.Add(Application.exeName);
     if ConstanteDlg.NewPageCB.itemIndex=0
        then Donnees.Add(Titre)
        else Donnees.Add('');
     Donnees.Add(ConstanteDlg.EditComm.text);
     Ligne := '';
     for j := voieX to DerniereVoie do with voie[j] do
         ligne := ligne + nom + crTab;
     Donnees.Add(ligne);
     Ligne := '';
     for j := voieX to DerniereVoie do with voie[j] do
         ligne := ligne + unite + crTab;
     Donnees.Add(ligne);
     Ligne := '';
     for j := voieX to DerniereVoie do with voie[j] do
         ligne := ligne + commentaire + crTab;
     Donnees.Add(ligne);
     setPhase;
     for i := 0 to pred(NbrePoints) do begin
         ligne := '';
         ligneOK := true;
         for j := voieX to DerniereVoie do with voie[j] do begin
            ligne := ligne + FloatToStrPoint(valeur[i]) + crTab;
            if isNan(valeur[i]) then begin
               ligneOK := false;
               break;
            end;
         end;
         if ligneOK then Donnees.Add(ligne);
     end;
     nbreCourbes := 0;
     avecdB := false;
     for j := succ(voieX) to derniereVoie do with voie[j] do
            if active then begin
               inc(NbreCourbes);
               avecdB := avecdB or axedB;
            end;
     if DDE then begin
        AjouteConst(donnees);
        donnees.Add(symbReg2+intToStr(NbreCourbes)+' NOMY');
        for j := succ(voieX) to derniereVoie do with voie[j] do
            if active then donnees.Add(nom);
        donnees.Add(symbReg2+intToStr(NbreCourbes)+' NOMX');
        for j := 1 to NbreCourbes do with voie[voieX] do
            donnees.Add(nom);
        if voie[voieX].axeLog then begin
            donnees.Add(symbReg2+'1 LOGX');
            donnees.Add('1');
        end;
     end;
     if DDE and not Bode then begin
        Donnees.Add(symbReg2+IntToStr(NbrePoints)+' INCERT');
        ligne := '';
        for i := 0 to pred(NbrePoints) do begin
            ligne := '';
            for j := voieX to DerniereVoie do
               ligne := ligne + FloatToStrPoint(voie[j].incertitude[i])+crTab;
            Donnees.Add(ligne);
        end;
     end;
     if DDE and Bode and avecdB then begin
           donnees.Add(symbReg2+'2 Decibel');
           for j := voieGain to voiePhase do with voie[j] do
              if axedB
                 then donnees.Add('1')
                 else donnees.Add('0');
     end;
     ClipBoard.AsText := Donnees.Text;
     if DDE then if ConstanteDlg.NewPageCB.itemIndex=0
          then Execute('CLIP|LOAD')
          else Execute('CLIP|ADD');
     Screen.Cursor := crDefault;
     ConstanteDlg.NewPageCB.itemIndex := 1;
     Donnees.free;
end end;

procedure TFormDDE.AjouteDonneesMultimetre(graphe : Tgraphe);
var i : indiceVecteur;
    j : indiceVoie;
    ligne : String;
    donnees : TstringList;
begin with graphe do begin
     Tri;
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     Ligne := '';
     for j := voieX to DerniereVoie do with voie[j] do
         ligne := ligne + nom + crTab;
     Donnees.Add(ligne);
     for i := 0 to pred(NbrePoints) do begin
         ligne := '';
         for j := voieX to DerniereVoie do
            ligne := ligne + FloatToStrPoint(voie[j].valeur[i]) + crTab;
         Donnees.Add(ligne);
     end;
     ClipBoard.AsText := Donnees.text;
     Execute('CLIP|PLUS');
     Screen.Cursor := crDefault;
     Donnees.Free;
end end;

procedure TFormDDE.FormCreate(Sender: TObject);
var Rini : TregIniFile;
begin
    RIni := TRegIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := RIni.ReadString('Regressi','Path','');
    RIni.Free;
    if ClientDDE.ServiceApplication='' then begin
       RIni := TRegIniFile.create('Software');
       ClientDDE.ServiceApplication := RIni.ReadString('Regressi','Path','');
       RIni.Free;
    end;
end;

procedure TFormDDE.EnvoieDonneesOscillo(DDE,UnePeriode : boolean);

Procedure ChercheUnTour(const X,Y : VecteurOsc;
                       N : indiceVecteurOsc;
                       var iDebut,iFin : indiceVecteurOsc);
const EcartMin = 0.04;
      EcartMax = 0.2;{ min, max pour hystrsis }
var i,i0 : indiceVecteurOsc;
    CoeffY,CoeffX : double;
    minLoc,ecartLoc : double;

Function GetCoeff(const V : VecteurOsc) : double;
var i : indiceVecteurOsc;
    mini,maxi : double;
begin
     Mini := V[1];
     Maxi := V[1];
     for i := 2 to N do
         if V[i]>Maxi
            then Maxi := V[i]
            else if V[i]<Mini
               then Mini := V[i];
      GetCoeff := 1/(Maxi-Mini);
end;

Procedure ChercheIdebut;
var xmin,xmax,ymin,ymax : integer;
    ixmin,ixmax,iymin,iymax : integer;
    i : integer;
begin
     ixmin := 1;
     ixmax := 1;
     iymin := 1;
     iymax := 1;
     i0 := 1;
     xmin := X[1];
     xmax := X[1];
     ymin := Y[1];
     ymax := Y[1];
     for i := 2 to N div 2 do begin
         if X[i]>xmax then begin
            xmax := x[i];
            ixmax := i;
         end;
         if X[i]<xmin then begin
            xmin := x[i];
            ixmin := i;
         end;
         if Y[i]>ymax then begin
            ymax := y[i];
            iymax := i;
         end;
         if Y[i]<ymin then begin
            ymin := y[i];
            iymin := i;
         end;
     end;
     if (ixmin<=ixmax) and
        (ixmin<=iymin) and
        (ixmin<=iymax)
          then i0 := ixmin
          else if (ixmax<=iymax) and
                  (ixmax<=iymin)
               then i0 := ixmax
               else if (iymin<=iymax)
                    then i0 := iymin
                    else i0 := iymax
end; { ChercheIdebut }

Function ecart : double;
begin
      ecart := abs(CoeffY*(Y[i]-Y[1]))+abs(CoeffX*(X[i]-X[1]))
end;

begin
     iFin := N;
     iDebut := 1;
     if N<16 then exit;
     CoeffY := GetCoeff(y);
     CoeffX := GetCoeff(x);
     ChercheIdebut;
     i := i0;
     repeat inc(i)
     until (ecart>ecartMax) or (i=N);
     { on est loin du dpart }
     if i=N then exit;
     repeat inc(i)
     until (ecart<ecartMin) or (i=N);
     { on est prs de la boucle }
     if i=N then exit;
     iFin := i;
     MinLoc := ecartMin;
     repeat
         inc(i);
         ecartLoc := ecart; { pour viter de calculer 3 fois }
         if ecartLoc<MinLoc then begin
             minLoc := ecartLoc;
             iFin := i;
         end; { on se rapproche }
     until (ecartLoc>ecartMin) or (i=N);
       { on sloigne de nouveau ou on a fini }
     if iFin<N then inc(iFin); { on ferme le tour }
     iDebut := i0;
end; { chercheUnTour }


var i : indiceVecteurOsc;
    v : indiceVoie;
    ligne : String;
    Donnees : TstringList;
    DebutOsc,FinOsc : indiceVecteurOsc;
begin with oscilloForm do begin
     Screen.Cursor := crHourGlass;
     Donnees := TstringList.create;
     Donnees.Add(Application.exeName);
     if ConstanteDlg.NewPageCB.itemIndex=0
        then Donnees.Add('Acquisition par '+string(FormMain.identiteScope))
        else Donnees.Add('');
     Donnees.Add(ConstanteDlg.EditComm.text);
     Ligne := '';
     for v := voieX to voieB do with voie[v] do if active then
         ligne := ligne + nom + crTab;
     Donnees.Add(ligne);
     Ligne := '';
     for v := voieX to voieB do with voie[v] do if active then
         ligne := ligne + unite + crTab;
     Donnees.Add(ligne);
     Ligne := '';
     for v := voieX to voieB do with voie[v] do if active then
         ligne := ligne + signif + crTab;
     Donnees.Add(ligne);
     if unePeriode
        then chercheUnTour(voie[voieA].valeur,voie[voieB].valeur,NbrePoints,DebutOsc,FinOsc)
        else begin
            DebutOsc := 1;
            FinOsc := NbrePoints;
        end;
     for i := debutOsc to FinOsc do begin
         ligne := '';
         for v := voieX to voieB do with voie[v] do if active then
             ligne := ligne + StrValeurPoint(i) + crTab;
         Donnees.Add(ligne);
     end;
     AjouteConst(donnees);
     ClipBoard.AsText := Donnees.text;
     if DDE then if ConstanteDlg.NewPageCB.itemIndex=0
           then Execute('CLIP|LOAD')
           else Execute('CLIP|ADD');
     ConstanteDlg.NewPageCB.itemIndex := 1;
     Screen.Cursor := crDefault;
     Donnees.free;
end end;

procedure TFormDDE.ServeurDDEExecuteMacro(Sender: TObject; Msg: TStrings);

Procedure FocusHP(NewPage : boolean);
begin
   with ConstanteDlg do begin
      if NewPage
         then NewPageCB.itemIndex := 1
         else NewPageCB.itemIndex := 0;
   end;
   case FormMain.AcquisitionEnCours of
        mMult : begin
             MultimetreForm.Show;
             MultimetreForm.SetFocus
        end;
        mOsc : begin
             OscilloForm.show;
             OscilloForm.setFocus
        end;
        else FormMain.setFocus;
   end;
end;

var Fonction,NomFichier : String;
    ArgStart,ArgEnd : byte;
begin
     if (Msg.Count >= 1) then begin
       try
       ArgStart := Pos('(',Msg[0]);
       ArgEnd := Pos(')',Msg[0]);
       if (ArgStart >= ArgEnd)
          then begin
             NomFichier := '';
             ArgStart := length(Msg[0])
          end
          else begin
              NomFichier := Copy(Msg[0], Succ(ArgStart), ArgEnd - Succ(ArgStart));
              dec(ArgStart)
          end;
       Fonction := Copy(Msg[0], 1, ArgStart);
       if (CompareText('CONFIG|LOAD',Fonction) = 0) or
          (CompareText('FILE|LOAD',Fonction) = 0) then begin
           FocusHP(true);
           exit
       end;
       if (CompareText('CONFIG|SAVE',Fonction) = 0) or
          (CompareText('FILE|SAVE',Fonction) = 0) then begin
           FocusHP(true);
           exit
       end;
       if CompareText('FOCUS',Fonction) = 0 then begin
           FocusHP(false);
           exit;
       end;
       if CompareText('GETDATA',Fonction) = 0 then begin
           FocusHP(true);
           exit;
       end;
       MessageDlg('Fonction inconnue : ' + Msg[0], mtError, [mbOK], 0);
       except
       end;
     end;
end;

end.
