unit VoieBode;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils, dialogs, inifiles,
  jmmUtil, Graphe, Spin, ComCtrls;

type
  TVoieBodeDlg = class(TForm)
    ActiveBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    GroupBox1: TGroupBox;
    decibelCB: TCheckBox;
    GammePC: TPageControl;
    DecibelTS: TTabSheet;
    NormalTS: TTabSheet;
    GroupBox3: TGroupBox;
    EditMaxidb: TEdit;
    MaxiSpin: TSpinButton;
    GroupBox4: TGroupBox;
    EditMinidB: TEdit;
    MiniSpin: TSpinButton;
    GroupBox5: TGroupBox;
    EditMaxi: TEdit;
    GroupBox2: TGroupBox;
    CouleurGain: TColorBox;
    DegreRG: TRadioGroup;
    GroupBox6: TGroupBox;
    CouleurPhase: TColorBox;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    EditPhaseMax: TEdit;
    MaxiSpinPhase: TSpinButton;
    GroupBox9: TGroupBox;
    EditPhaseMin: TEdit;
    MiniSpinPhase: TSpinButton;
    procedure ActiveBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure decibelCBClick(Sender: TObject);
    procedure MaxiSpinUpClick(Sender: TObject);
    procedure MaxiSpinDownClick(Sender: TObject);
    procedure MiniSpinDownClick(Sender: TObject);
    procedure MiniSpinUpClick(Sender: TObject);
  private
    function StrDecibel(var valeur : double) : string;
  public
  end;

var
  VoieBodeDlg: TVoieBodeDlg;

implementation

uses Bode;

{$R *.DFM}
const facteur = 3;

function TVoieBodeDlg.StrDecibel(var valeur : double) : string;
var valeurdb : integer;
begin
     valeurdb := round(20*log(valeur));
     valeur := DixReel(valeurdB/20);
     result := floatToStr(valeurdb)+'dB'
end;

procedure TVoieBodeDlg.ActiveBtnClick(Sender: TObject);
begin
with BodeForm.graphe.voie[voieGain] do begin
     couleur := couleurGain.selected;
     axedB := decibelCB.checked;
     if axedB
        then begin
             if mini=0 then mini := maxi/10;
        end
        else begin
          Mini := 0;
          try
          Maxi := StrToFloat(EditMaxi.text);
          except
          end;
        end;
end;
with BodeForm.graphe.voie[voiePhase] do begin
     couleur := couleurPhase.selected;
     enDegre := boolean(degreRG.ItemIndex);
end
end;

procedure TVoieBodeDlg.FormActivate(Sender: TObject);
begin
with BodeForm.graphe.voie[voieGain] do begin
     EditMaxi.text := FloatToStr(Maxi);
     CouleurGain.selected := couleur;
     decibelCB.checked := axedB;
     if axedb
        then begin
           try
           EditMinidB.text := StrDecibel(mini);
           except
              EditMinidB.text := '-20 dB';
              mini := 0.1;
           end;
        end
        else EditMinidB.text := '-20 dB';
     try
     EditMaxidB.text := StrDecibel(maxi);
     except
         maxi := 10;
         EditMaxidB.text := '+20 dB';
     end;
     decibelCBClick(Sender);
end;
with BodeForm.graphe.voie[voiePhase] do begin
     CouleurPhase.selected := couleur;
     degreRG.ItemIndex := ord(EnDegre);
end
end;

procedure TVoieBodeDlg.decibelCBClick(Sender: TObject);
begin
     if decibelCB.checked
        then GammePC.ActivePageIndex := 0
        else GammePC.ActivePageIndex := 1
end;

procedure TVoieBodeDlg.MaxiSpinUpClick(Sender: TObject);
begin with BodeForm.graphe.voie[voieGain] do begin
     if maxi<=1e5
        then maxi := maxi*facteur
        else Erreur('Maxi = 100 dB');
     EditMaxiDb.text := StrDecibel(maxi);
end end;

procedure TVoieBodeDlg.MaxiSpinDownClick(Sender: TObject);
begin with BodeForm.graphe.voie[voieGain] do begin
     if maxi>=10*mini
        then maxi := maxi/facteur
        else Erreur('Maxi trop proche du mini');
     EditMaxiDb.text := StrDecibel(maxi);
end end;

procedure TVoieBodeDlg.MiniSpinDownClick(Sender: TObject);
begin with BodeForm.graphe.voie[voieGain] do begin
     if mini=0 then mini := maxi/10;
     if mini>=1e-5
        then mini := mini/facteur
        else Erreur('Mini = -100 dB');
     EditMiniDb.text := StrDecibel(mini);
end end;

procedure TVoieBodeDlg.MiniSpinUpClick(Sender: TObject);
begin with BodeForm.graphe.voie[voieGain] do begin
     if mini=0 then mini := maxi/10;
     if mini<=maxi/10
        then mini := mini*facteur
        else Erreur('Mini trop proche du maxi');
     EditMiniDb.text := StrDecibel(mini);
end end;

end.
