unit voieGainU;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils, dialogs,
  jmmUtil, Graphe, Spin, ComCtrls;

type
  TVoieGainDlg = class(TForm)
    ActiveBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    GroupBox1: TGroupBox;
    decibelCB: TCheckBox;
    GammePC: TPageControl;
    DecibelTS: TTabSheet;
    NormalTS: TTabSheet;
    GroupBox3: TGroupBox;
    EditMaxidb: TEdit;
    MaxiSpin: TSpinButton;
    GroupBox4: TGroupBox;
    EditMinidB: TEdit;
    MiniSpin: TSpinButton;
    GroupBox5: TGroupBox;
    EditMaxi: TEdit;
    GroupBox2: TGroupBox;
    CouleurGain: TColorBox;
    StatusBar1: TStatusBar;
    procedure ActiveBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure decibelCBClick(Sender: TObject);
    procedure MaxiSpinUpClick(Sender: TObject);
    procedure MaxiSpinDownClick(Sender: TObject);
    procedure MiniSpinDownClick(Sender: TObject);
    procedure MiniSpinUpClick(Sender: TObject);
  private
    function Strdecibel(var valeur : double) : String;
  public
  end;

var
  VoieGainDlg: TVoieGainDlg;

implementation

uses Bode;

{$R *.DFM}
const facteur = 3;

function TVoieGainDlg.StrDecibel(var valeur : double) : String;
var valeurdb : integer;
begin
     valeurdb := round(20*log(valeur));
     valeur := DixReel(valeurdB/20);
     result := floatToStr(valeurdb)+'dB'
end;

procedure TVoieGainDlg.ActiveBtnClick(Sender: TObject);
begin
with BodeForm.graphe.voie[voieGain] do begin
     couleur := couleurGain.selected;
     axedB := decibelCB.checked;
     if axedB
        then begin
             if mini=0 then mini := maxi/10;
        end
        else begin
          Mini := 0;
          try
          Maxi := StrToFloat(EditMaxi.text);
          except
          end;
        end;
end end;

procedure TVoieGainDlg.FormActivate(Sender: TObject);
begin
with BodeForm.graphe.voie[voieGain] do begin
     EditMaxi.text := FormatCourt(Maxi,'');
     CouleurGain.selected := couleur;
     decibelCB.checked := axedB;
     if axedb then begin
         try
         EditMinidB.text := StrDecibel(mini);
         except
            EditMinidB.text := '-20 dB';
            mini := 0.1;
         end;
     end;
     try
     EditMaxidB.text := StrDecibel(maxi);
     except
         maxi := 10;
         EditMaxidB.text := '+20 dB';
     end;
     decibelCBClick(Sender);
end end;

procedure TVoieGainDlg.decibelCBClick(Sender: TObject);
begin
     if decibelCB.checked
        then GammePC.ActivePageIndex := 0
        else GammePC.ActivePageIndex := 1
end;

procedure TVoieGainDlg.MaxiSpinUpClick(Sender: TObject);
begin with BodeForm.graphe.voie[voieGain] do begin
     if maxi<=1e6
        then begin
           maxi := maxi*facteur;
           StatusBar1.SimpleText := '';
        end
        else StatusBar1.SimpleText := 'Maxi <= 120 dB';
     EditMaxiDb.text := StrDecibel(maxi);
end end;

procedure TVoieGainDlg.MaxiSpinDownClick(Sender: TObject);
begin with BodeForm.graphe.voie[voieGain] do begin
     if maxi>=10*mini
        then begin
           maxi := maxi/facteur;
           StatusBar1.SimpleText := '';
        end
        else StatusBar1.SimpleText := 'Maxi trop proche du mini';
     EditMaxiDb.text := StrDecibel(maxi);
end end;

procedure TVoieGainDlg.MiniSpinDownClick(Sender: TObject);
begin with BodeForm.graphe.voie[voieGain] do begin
     if mini=0 then mini := maxi/10;
     if mini>=1e-6
        then begin
           mini := mini/facteur;
           StatusBar1.SimpleText := '';
        end
        else StatusBar1.SimpleText := 'Mini = -120 dB';
     EditMiniDb.text := StrDecibel(mini);
end end;

procedure TVoieGainDlg.MiniSpinUpClick(Sender: TObject);
begin with BodeForm.graphe.voie[voieGain] do begin
     if mini=0 then mini := maxi/10;
     if mini<=maxi/10
        then begin
           mini := mini*facteur;
           StatusBar1.SimpleText := '';
        end
        else StatusBar1.SimpleText := 'Mini trop proche du maxi';
     EditMiniDb.text := StrDecibel(mini);
end end;

end.
