unit voiePhaseU;

interface

uses Windows, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, SysUtils, dialogs,
  jmmUtil, Graphe, Spin, ComCtrls;

type
  TVoiePhaseDlg = class(TForm)
    ActiveBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Bevel1: TBevel;
    DegreRG: TRadioGroup;
    GroupBox6: TGroupBox;
    CouleurPhase: TColorBox;
    GroupBox7: TGroupBox;
    GroupBox8: TGroupBox;
    EditPhaseMax: TEdit;
    MaxiSpinPhase: TSpinButton;
    GroupBox9: TGroupBox;
    EditPhaseMin: TEdit;
    MiniSpinPhase: TSpinButton;
    StatusBar1: TStatusBar;
    procedure ActiveBtnClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure MaxiSpinUpClick(Sender: TObject);
    procedure MaxiSpinDownClick(Sender: TObject);
    procedure MiniSpinDownClick(Sender: TObject);
    procedure MiniSpinUpClick(Sender: TObject);
    procedure DegreRGClick(Sender: TObject);
  private
    function StrPhase(var valeur : double) : String;
  public
  end;

var
  VoiePhaseDlg: TVoiePhaseDlg;

implementation

uses Bode;

{$R *.DFM}

const increment : array[boolean] of double = (1.57,90);

function TVoiePhaseDlg.StrPhase(var valeur : double) : String;
begin
     if enDegre
        then result := intToStr(90*round(valeur/90))+' '
        else result := intToStr(round(valeur/pi*2))+' /2 rad'
end;

procedure TVoiePhaseDlg.ActiveBtnClick(Sender: TObject);
begin
with BodeForm.graphe.voie[voiePhase] do begin
     couleur := couleurPhase.selected;
     enDegre := boolean(degreRG.ItemIndex);
end end;

procedure TVoiePhaseDlg.FormActivate(Sender: TObject);
begin
with BodeForm.graphe.voie[voiePhase] do begin
     CouleurPhase.selected := couleur;
     degreRG.ItemIndex := ord(EnDegre);
     EditPhaseMax.text := strPhase(maxi);
     EditPhaseMin.text := strPhase(mini);
end end;

procedure TVoiePhaseDlg.MaxiSpinUpClick(Sender: TObject);
begin with BodeForm.graphe.voie[voiePhase] do begin
        maxi := maxi+increment[enDegre];
        StatusBar1.SimpleText := '';
        if maxi>5*increment[enDegre]/2 then begin
           StatusBar1.SimpleText := 'Maxi <= 180 ';
           maxi := 2*increment[enDegre];
        end;
        EditPhaseMax.text := strPhase(maxi);
end end;

procedure TVoiePhaseDlg.MaxiSpinDownClick(Sender: TObject);
begin with BodeForm.graphe.voie[voiePhase] do begin
     maxi := maxi-increment[enDegre];
     StatusBar1.SimpleText := '';
     if (maxi-mini)<increment[enDegre]/2 then begin
           maxi := mini+increment[enDegre];
           StatusBar1.SimpleText := 'Maxi trop proche du mini';
     end;
     if maxi<0 then begin
        StatusBar1.SimpleText := 'Maxi >= 0';
        maxi := 0;
     end;
     EditPhaseMax.text := strPhase(maxi);
end end;

procedure TVoiePhaseDlg.MiniSpinDownClick(Sender: TObject);
begin with BodeForm.graphe.voie[voiePhase] do begin
        mini := mini-increment[enDegre];
        StatusBar1.SimpleText := '';
        if mini<-5*increment[enDegre]/2 then begin
           StatusBar1.SimpleText := 'Mini >= -180 ';
           mini := -2*increment[enDegre];
        end;
        EditPhaseMin.text := strPhase(mini);
end end;

procedure TVoiePhaseDlg.MiniSpinUpClick(Sender: TObject);
begin with BodeForm.graphe.voie[voiePhase] do begin
     mini := mini+increment[enDegre];
     StatusBar1.SimpleText := '';
     if (maxi-mini)<increment[enDegre]/2 then begin
          mini := maxi-increment[enDegre];
          StatusBar1.SimpleText := 'Mini trop proche du maxi';
     end;
     if mini>0 then begin
        StatusBar1.SimpleText := 'Mini <= 0';
        mini := 0;
     end;
     EditPhaseMin.text := strPhase(mini);
end end;

procedure TVoiePhaseDlg.DegreRGClick(Sender: TObject);
begin with BodeForm.graphe.voie[voiePhase] do begin
    EnDegre := boolean(DegreRG.itemIndex);
    if enDegre
       then begin
            if (abs(maxi)+abs(mini))<90
            then begin
               maxi := maxi*180/pi;
               mini := mini*180/pi;
            end
       end
       else begin
            if (abs(maxi)+abs(mini))>90
            then begin
               maxi := maxi*pi/180;
               mini := mini*pi/180;
            end
       end;
       EditPhaseMax.text := strPhase(maxi);
       EditPhaseMin.text := strPhase(mini);
end end;

end.
